import { DataObject, VNode } from "dom-renderer";
export interface ComponentMeta extends ElementDefinitionOptions, Partial<ShadowRootInit> {
    tagName: string;
}
/**
 * Class decorator of Web components
 */
export function component({ tagName, ...meta }: ComponentMeta): <T extends CustomElementConstructor>(Class: T, { addInitializer }: ClassDecoratorContext) => T;
export type FunctionComponent<P extends DataObject = {}> = (props: P) => VNode;
export type FC<P extends DataObject = {}> = FunctionComponent<P>;
export type ClassComponent = CustomElementConstructor;
export type WebCellComponent = FunctionComponent | ClassComponent;
/**
 * Class decorator of Web components for MobX
 */
export function observer<T extends WebCellComponent>(func: T, _: ClassDecoratorContext): T;
export function observer<T extends WebCellComponent>(func: T): T;
declare global {
    namespace JSX {
        interface ElementAttributesProperty {
            props: {};
        }
    }
}

//# sourceMappingURL=index.d.ts.map
