import {DOMRenderer as $42h8L$DOMRenderer} from "dom-renderer";
import {autorun as $42h8L$autorun} from "mobx";
import {isHTMLElementClass as $42h8L$isHTMLElementClass} from "web-utility";




function $9f55261c90a8da96$export$d8556a2a8f973135({ tagName: tagName, ...meta }) {
    return (Class, { addInitializer: addInitializer })=>{
        class RendererComponent extends Class {
            internals = this.attachInternals();
            renderer = new (0, $42h8L$DOMRenderer)();
            constructor(){
                super();
                if (meta.mode) this.attachShadow(meta);
            }
            connectedCallback() {
                this.update();
                // @ts-ignore
                super.connectedCallback?.();
            }
            update() {
                const vNode = this.render?.(), { shadowRoot: shadowRoot } = this.internals;
                // @ts-ignore
                if (vNode) this.renderer.render(vNode, shadowRoot || this);
            }
        }
        addInitializer(function() {
            globalThis.customElements?.define(tagName, this, meta);
        });
        return RendererComponent;
    };
}
function $9f55261c90a8da96$var$wrapFunction(func) {
    return (props)=>{
        var tree, renderer = new (0, $42h8L$DOMRenderer)();
        const disposer = (0, $42h8L$autorun)(()=>{
            const newTree = func(props);
            tree = tree ? renderer.patch(tree, newTree) : newTree;
        });
        const { unRef: unRef } = tree;
        tree.unRef = (node)=>(disposer(), unRef?.(node));
        return tree;
    };
}
function $9f55261c90a8da96$var$wrapClass(Class) {
    class ObserverComponent extends Class {
        disposers = [];
        constructor(){
            super();
            const { update: update } = Object.getPrototypeOf(this);
            // @ts-ignore
            this.update = ()=>this.disposers.push((0, $42h8L$autorun)(()=>update.call(this)));
        }
        disconnectedCallback() {
            for (const disposer of this.disposers)disposer();
        }
    }
    return ObserverComponent;
}
function $9f55261c90a8da96$export$b6ae1bc530f4c149(func, _) {
    return (0, $42h8L$isHTMLElementClass)(func) ? $9f55261c90a8da96$var$wrapClass(func) : $9f55261c90a8da96$var$wrapFunction(func);
}


export {$9f55261c90a8da96$export$d8556a2a8f973135 as component, $9f55261c90a8da96$export$b6ae1bc530f4c149 as observer};
//# sourceMappingURL=index.esm.js.map
